var midMozdevOrgOnCtxMenuEvents = {

  MID_TAB_URL : "chrome://mid/content/mid.xul?tab",
  retries : 0, 
  mid_prefsvc : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
  
  onLoad: function() {
    // initialization code
    midMozdevOrgOnCtxMenuEvents.initialized = true;
    midMozdevOrgOnCtxMenuEvents.strings = document.getElementById("midMozdevOrgOnCtxMenuEvents-strings");
    document.getElementById("contentAreaContextMenu")
            .addEventListener("popupshowing", function(e) { midMozdevOrgOnCtxMenuEvents.showContextMenu(e); }, false);
  },

  showContextMenu: function(event) {

      var myitem = document.getElementById("mid-mozdev-org-ctx-menuitm");
      midMozdevOrgOnCtxMenuEvents.retries = 0;
      if ((midMozdevOrgOnCtxMenuEvents.getTextSelected().length == 0) || !midMozdevOrgOnCtxMenuEvents.isContextEnabled()) {
          myitem.hidden = true;
      } else {
          myitem.hidden = false;
      }
  },

  onMenuItemCommand: function(e) {

        function fibonacci(n) {
            if (n==1 || n==2 ) {
               return 1;
            }
            return fibonacci(n-1) + fibonacci(n-2);
        }

       var timer1 = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);                                                                  
       var timer2 = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);                                                                  
        
       var callbackFunction1  = {
            notify: function(timer1) {
              midMozdevOrgOnToolsMenuEvents.newMIDWindow();
            }
        }
       var callbackFunction2 = {
            notify: function(timer2) {
               midMozdevOrgOnCtxMenuEvents.onMenuItemCommand()
            }
        }


        var selText = midMozdevOrgOnCtxMenuEvents.getTextSelected();
        var tab = null;  tab = midMozdevOrgOnCtxMenuEvents.findMidTab();

        if (tab) {
           var b = gBrowser.getBrowserForTab(tab); 
           win = b.contentWindow;
           win.domHelper.inputElement.value = selText;
           win.mid_mud.lookup.lookupWord();
           return;
        }

        const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
        var windowMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
        windowMediator = windowMediator.QueryInterface(nsIWindowMediator);
        var win = windowMediator.getMostRecentWindow("mid:main");

        if (!win || !win.domHelper) {
            midMozdevOrgOnCtxMenuEvents.retries = midMozdevOrgOnCtxMenuEvents.retries + 1;
            if (midMozdevOrgOnCtxMenuEvents.retries > 10) {
                midMozdevOrgOnCtxMenuEvents.retries = 0; 
                alert("mid not found :(");
                return;                            // couldn't start mid
            } else { 
                if (midMozdevOrgOnCtxMenuEvents.retries == 1) {
                    timer1.initWithCallback(callbackFunction1, 15, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
                }
            }
            var szam = 300 + fibonacci(midMozdevOrgOnCtxMenuEvents.retries)*100 ;
            timer2.initWithCallback(callbackFunction2, szam , Components.interfaces.nsITimer.TYPE_ONE_SHOT);
            return;
        } else {
            win.domHelper.inputElement.value = selText;
            win.mid_mud.lookup.lookupWord();
            win.focus();
        }
 
        midMozdevOrgOnCtxMenuEvents.retries = 0;

  },

  getTextSelected: function() {

        var selection = "";
        var node = document.popupNode;
        var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document', 'getSelection()');

        if ((node instanceof HTMLTextAreaElement) || ((node instanceof HTMLInputElement) && (node.type == "text")))  {
             selection = node.value.substring(node.selectionStart, node.selectionEnd);
        } else {
          selection = focusedWindow.getSelection().toString();
        }

   return selection;

  },

  isContextEnabled : function() {
      if (midMozdevOrgOnCtxMenuEvents.mid_prefsvc.getPrefType("extensions.mid.menus.sendfromcontext") == midMozdevOrgOnCtxMenuEvents.mid_prefsvc.PREF_BOOL) {
          if (midMozdevOrgOnCtxMenuEvents.mid_prefsvc.getBoolPref("extensions.mid.menus.sendfromcontext")) {
              return true;
          }
      }
      return false;
  },

  findMidTab : function() {
  // Look for an existing tab
      var tab = false;
      var numTabs = gBrowser.browsers.length;
      for(var index = 0; index < numTabs; index++) {
          var currentBrowser = gBrowser.getBrowserAtIndex(index);
          if(this.MID_TAB_URL == currentBrowser.currentURI.spec) {
             tab = (gBrowser.tabs ? gBrowser.tabs : gBrowser.mTabs)[index];
             break;
          }
     } 

     return tab;
  }



};

window.addEventListener("load", function(e) { midMozdevOrgOnCtxMenuEvents.onLoad(e); }, false);

var midMozdevOrgOnToolsMenuEvents = {

     mid_prefsvc : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),

     onLoad: function() {
       // initialization code
       midMozdevOrgOnToolsMenuEvents.initialized = true;
       midMozdevOrgOnToolsMenuEvents.strings = document.getElementById("midMozdevOrgOnToolsMenuEvents-strings");
       var ovrmenu = document.getElementById("menu_ToolsPopup") || document.getElementById("taskPopup")  // Firefox or Seamonkey
       if (ovrmenu) {
           ovrmenu.addEventListener("popupshowing", function(e) {midMozdevOrgOnToolsMenuEvents.showToolsMenu(e);}, false);
       }
      // toJavaScriptConsole()
     },
    
     // taskPopup menu_ToolsPopup

      showToolsMenu: function(event) {

        var myitem = document.getElementById("mid-mozdev-org-tools-menuitem");
        midMozdevOrgOnToolsMenuEvents.retries = 0;
        if (!midMozdevOrgOnToolsMenuEvents.isToolsMenuEnabled()) {
           myitem.hidden = true;
        } else {
           myitem.hidden = false;
        }
    },



    isToolsMenuEnabled : function() {

        if (midMozdevOrgOnToolsMenuEvents.mid_prefsvc.getPrefType("extensions.mid.menus.startfromtask") == midMozdevOrgOnToolsMenuEvents.mid_prefsvc.PREF_BOOL) {
            if (midMozdevOrgOnToolsMenuEvents.mid_prefsvc.getBoolPref("extensions.mid.menus.startfromtask")) {
                return true;
            }
        }
        return false;
    },



    toMIDWindow : function (event) {
                   // try to get the existing window //
        toOpenWindowByType("mid:main", 'chrome://mid/content/');
    },
    
    newMIDWindow : function (event) {
                  // Open a new window
        if  (event && event.shiftKey) {
            this.newMIDTab()
            return;
        }
        window.open("chrome://mid/content/",'_blank','chrome=yes,resizable=yes,scrollbars=yes');

    },

    newMIDTab : function () {
         var prevFunc = XULBrowserWindow.hideChromeForLocation;
         XULBrowserWindow.hideChromeForLocation = function(aLocation) {
            return aLocation == "chrome://mid/content/mid.xul?tab"  ||  prevFunc.apply(XULBrowserWindow, [aLocation]); }
         var tab = gBrowser.addTab("chrome://mid/content/mid.xul?tab"); 
         if  (tab && gBrowser.pinTab) gBrowser.pinTab(tab);
    }
    
}

window.addEventListener("load", function(e) { midMozdevOrgOnToolsMenuEvents.onLoad(e); }, false);

